alpm_databases(3)

NAME
alpm_databases - Functions to query and manipulate the database of libalpm.

SYNOPSIS

  Functions
int alpm_db_update (int force, alpm_db_t *db)
Update a package database.
alpm_db_t * alpm_register_syncdb (alpm_handle_t *handle, const char *treename, int siglevel)
Register a sync database of packages.
void _alpm_db_unregister (alpm_db_t *db)
int alpm_unregister_all_syncdbs (alpm_handle_t *handle)
Unregister all package databases.
int alpm_db_unregister (alpm_db_t *db)
Unregister a package database.
alpm_list_t * alpm_db_get_servers (const alpm_db_t *db)
Get the serverlist of a database.
int alpm_db_set_servers (alpm_db_t *db, alpm_list_t *servers)
Set the serverlist of a database.
int alpm_db_add_server (alpm_db_t *db, const char *url)
Add a download server to a database.
int alpm_db_remove_server (alpm_db_t *db, const char *url)
Remove a download server from a database.
const char * alpm_db_get_name (const alpm_db_t *db)
Get the name of a package database.
int alpm_db_get_siglevel (alpm_db_t *db)
Get the signature verification level for a database.
int alpm_db_get_valid (alpm_db_t *db)
Check the validity of a database.
alpm_pkg_t * alpm_db_get_pkg (alpm_db_t *db, const char *name)
Get a package entry from a package database.
alpm_list_t * alpm_db_get_pkgcache (alpm_db_t *db)
Get the package cache of a package database.
alpm_group_t * alpm_db_get_group (alpm_db_t *db, const char *name)
Get a group entry from a package database.
alpm_list_t * alpm_db_get_groupcache (alpm_db_t *db)
Get the group cache of a package database.
alpm_list_t * alpm_db_search (alpm_db_t *db, const alpm_list_t *needles)
Searches a database.
int alpm_db_set_usage (alpm_db_t *db, int usage)
Sets the usage bitmask for a repo.
int alpm_db_get_usage (alpm_db_t *db, int *usage)
Gets the usage bitmask for a repo.

Detailed Description

Functions to query and manipulate the database of libalpm.

Function Documentation

  int alpm_db_add_server (alpm_db_t * db, const char * url)

Add a download server to a database.

Parameters
    db database pointer
    url url of the server

Returns
    0 on success, -1 on error (pm_errno is set accordingly)

  alpm_group_t* alpm_db_get_group (alpm_db_t * db, const char * name)

Get a group entry from a package database.

Parameters
    db pointer to the package database to get the group from
    name of the group

Returns
    the groups entry on success, NULL on error

Referenced by alpm_find_group_pkgs().

  alpm_list_t* alpm_db_get_groupcache (alpm_db_t * db)

Get the group cache of a package database.

Parameters
    db pointer to the package database to get the group from

Returns
    the list of groups on success, NULL on error

  const char* alpm_db_get_name (const alpm_db_t * db)

Get the name of a package database.

Parameters
    db pointer to the package database

Returns
    the name of the package database, NULL on error

  alpm_pkg_t* alpm_db_get_pkg (alpm_db_t * db, const char * name)

Get a package entry from a package database.

Parameters
    db pointer to the package database to get the package from
    name of the package

Returns
    the package entry on success, NULL on error

  alpm_list_t* alpm_db_get_pkgcache (alpm_db_t * db)

Get the package cache of a package database.

Parameters
    db pointer to the package database to get the package from

Returns
    the list of packages on success, NULL on error

  alpm_list_t* alpm_db_get_servers (const alpm_db_t * db)

Get the serverlist of a database.

  int alpm_db_get_siglevel (alpm_db_t * db)

Get the signature verification level for a database. Will return the default verification level if this database is set up with ALPM_SIG_USE_DEFAULT.

Parameters
    db pointer to the package database

Returns
    the signature verification level

  int alpm_db_get_usage (alpm_db_t * db, int * usage)

Gets the usage bitmask for a repo. Gets the usage of a database.

  int alpm_db_get_valid (alpm_db_t * db)

Check the validity of a database. This is most useful for sync databases and verifying signature status. If invalid, the handle error code will be set accordingly.

Parameters
    db pointer to the package database

Returns
    0 if valid, -1 if invalid (pm_errno is set accordingly)

  int alpm_db_remove_server (alpm_db_t * db, const char * url)

Remove a download server from a database.

Parameters
    db database pointer
    url url of the server

Returns
    0 on success, 1 on server not present, -1 on error (pm_errno is set accordingly)

  alpm_list_t* alpm_db_search (alpm_db_t * db, const alpm_list_t * needles)

Searches a database. Searches a database with regular expressions.

  int alpm_db_set_servers (alpm_db_t * db, alpm_list_t * servers)

Set the serverlist of a database.

  int alpm_db_set_usage (alpm_db_t * db, int usage)

Sets the usage bitmask for a repo. Sets the usage of a database.

  int alpm_db_unregister (alpm_db_t * db)

Unregister a package database.

Parameters
    db pointer to the package database to unregister

Returns
    0 on success, -1 on error (pm_errno is set accordingly)

  int alpm_db_update (int force, alpm_db_t * db)

Update a package database. An update of the package database db will be attempted. Unless force is true, the update will only be performed if the remote database was modified since the last update.

This operation requires a database lock, and will return an applicable error if the lock could not be obtained.

Example:

alpm_list_t *syncs = alpm_get_syncdbs();
for(i = syncs; i; i = alpm_list_next(i)) {
    alpm_db_t *db = alpm_list_getdata(i);
    result = alpm_db_update(0, db);
    if(result < 0) {
        printf("Unable to update database: %s, alpm_strerrorlast());
    } else if(result == 1) {
        printf("Database already up to date);
    } else {
        printf("Database updated);
    }
}

Note
    After a successful update, the package cache will be invalidated

Parameters
    force if true, then forces the update, otherwise update only in case the database isn't up to date
    db pointer to the package database to update

Returns
    0 on success, -1 on error (pm_errno is set accordingly), 1 if up to to date

  alpm_db_t* alpm_register_syncdb (alpm_handle_t * handle, const char * treename, int level)

Register a sync database of packages.

Parameters
    handle the context handle
    treename the name of the sync repository
    level what level of signature checking to perform on the database; note that this must be a '.sig' file type verification

Returns
    an alpm_db_t* on success (the value), NULL on error

  int alpm_unregister_all_syncdbs (alpm_handle_t * handle)

Unregister all package databases.

Parameters
    handle the context handle

Returns
    0 on success, -1 on error (pm_errno is set accordingly)

Referenced by alpm_release().

Author

Generated automatically by Doxygen for libalpm from the source code.